a=exp(j*120*pi()/180)

%ej1 parte A
Ubase150=150
Ubase315=31.5
Ubase138=13.8
Sbase=6
Zbase150=Ubase150^2/Sbase
Zbase315=Ubase315^2/Sbase
Zbase138=Ubase138^2/Sbase

Ub=156/Ubase150

%impedancias de transformadores
Xt1=0.06*j
Xt2=Xt1


Xt=0.08*(150^2/10)*j/Zbase150

%impedancias R1 Y R2
R1=595/3/Zbase315
R2=248/Zbase315

R10=Inf
R20=R2
 
%Impedancias de lineas
Zls=0.1*j/Zbase150
Zl0=0.3*j/Zbase150

%imp neutro
Zn=1*j/Zbase138

%imp gen
Xgens=0.15*(13.8^2/10)*j/Zbase138
Xgen0=0.05*(13.8^2/10)*j/Zbase138

% calculo de la corriente y la potencia saliente de B
I1=Ub/(Xt1+R1)
Ibase=Sbase/(sqrt(3)*Ubase150)
I2=Ub/(Xt2+R2)
I=I1+I2
S=Ub*conj(I)
P=real(S)


% %ya calcule la potencia saliente S desde la barra B 
% %calculo la potencia que entrega el generador calculando primero la
% %impedancia que esta entre la barra B y la del generador.
 
ZtotAB=Xt+Zls
Sgen=S+ZtotAB*abs(S)^2/abs(Ub)^2
Ugen=abs(Ub)+ZtotAB*conj(S)/abs(Ub)
Stotalgenerador=Sgen*Sbase %borrar hasta aca

% %ej1 parte B



%imp secuenciales
Zs=paralelo3(Xgens+Xt+Zls,Xt1+R1,Xt2+R2)
Za=Zs
Z0=paralelo(Xgen0+3*Zn+Xt+Zl0,Xt2)

%calculo de corrientes para 1FT
Id=Ub/(Zs+Za+Z0)
Ia=Id
I0=Id

%Quiero la corriente por la rama del generador para eso calculo el factor
%de distribucion para la sec cero, la pos y la neg que son iguales
Fd=Zs/(Xgens+Xt+Zls)
Fa=Fd
F0=Z0/(Xgen0+3*Zn+Xt+Zl0)

Idgen=Fd*Id
Iagen=Fa*Ia
I0gen=F0*I0

Iini=Sgen/Ugen

Idtot=Idgen+Iini %revisar signo y preguntar
Iatot=Iagen
I0tot=I0gen

I1=abs(Idtot+Iatot+I0tot)
I2=abs(Idtot*a^2+a*Iatot+I0tot)
I3=abs(Idtot*a+a^2*Iatot+I0tot)

Ud=-Idgen*(Xgens)
Ua=-Iagen*(Xgens)
U0=-I0gen*(Xgen0)

Udtot=Ud+Ugen
Uatot=Ua
U0tot=U0

U1=abs(Udtot+Uatot+U0tot)
U2=abs(Udtot*a^2+a*Uatot+U0tot)
U3=abs(Udtot*a+a^2*Uatot+U0tot)


Stot=Udtot*conj(Idtot)+conj(Iatot)*Uatot+U0tot*conj(I0tot)  % esta cuenta esta en pu esta bien?
Stotfisicas=Stot*Sbase

