j
%ej1 parte A
Ubase150=150
Ubase15=15
Sbase=10
Zbase150=Ubase150^2/Sbase
Zbase15=Ubase15^2/Sbase

%impedancias de transformadores
Xt=0.03*j
%ZIGZAG
X0=1*j/Zbase15

%Impedancias de lineas
Zls=50*j/Zbase150
Zl0=150*j/Zbase150

%imp neutro
Zn=1*j/Zbase150

%imp gen
 Xgens=0.15*j
 Xgen0=0.05*j
 
 %imp de carga
 Z1=45*j/3/Zbase15
 Z2=85*j/3/Zbase15
 
%ej2 parte B
Ub=15.8/Ubase15
Idini=Ub/Z1

%imp secuenciales
Zs=paralelo(Z2,Xt/2+Zls+paralelo(Xt+Xgens,Zls+Xt/2+Z1))
Za=Zs
Z0=3*Zn+(Xt/2)+Zl0+paralelo(Xt,Zl0+Xt/2)


%calculo de corrientes para 1FT que ocurren en la falta
Id=(Ub/(Zs+Za+Z0))
Ia=Id
I0=Id


%la tension previa al defecto directa en el punto del neutro es cero.
%La tesnion post defecto en el borne del neutro es una tension homopolar
%Por lo tanto como solo pueden circular corrientes homopolares que generen
%esta tension solo me interesa la corriente homopolar de falta.
Uini=0

Ud=0
Ui=0
U0=-I0*((Xt/2)+Zl0+paralelo(Xt,Zl0+Xt/2))

Uneutro=U0*Ubase150


